package ru.pricepulse.parsingservice.wildberries_parser.service.client;

import lombok.AllArgsConstructor;
import lombok.extern.slf4j.Slf4j;
import org.springframework.core.ParameterizedTypeReference;
import org.springframework.http.HttpEntity;
import org.springframework.http.HttpMethod;
import org.springframework.http.ResponseEntity;
import org.springframework.retry.annotation.Retryable;
import org.springframework.stereotype.Service;
import org.springframework.web.client.RestTemplate;
import ru.pricepulse.parsingservice.config.MarketplacesConfig;

import java.util.Map;

@AllArgsConstructor
@Service
@Slf4j
public class ClientImpl implements Client {

    private final RestTemplate restTemplate;
    private final MarketplacesConfig marketplacesConfig;

    @Override
    @Retryable(maxAttempts = 50, value = RuntimeException.class)
    public Map<String, Object> scrapPage(int page, String shard, String query) {
        String url = marketplacesConfig.getWildberriesConfigProperties().getCatalogWbUrl() +
                shard +
                query +
                "?dest=-1257786&page=" + page + "&subject=2290";

        ResponseEntity<Map<String, Object>> response = restTemplate.exchange(
                url,
                HttpMethod.GET,
                HttpEntity.EMPTY,
                new ParameterizedTypeReference<>() {
                }
        );

        return response.getBody();
    }
}
